{$A+} {Word allign}
{$F-} {Use NEAR calls}
{$G-} {8086 instructions}
{$D-} {Strip debug information}
{$B-} {Short boolean evaluation}
{$L-} {Do not generate local symbols information}
{$M, 16384,0,0}

USES AdvHSC;

CONST
  Copyright : STRING[27] = 'cTgfwn|0y'#26'\Ǝ';
                          {'Code & Gfx by The GodFather';}

  SSpd = -1;
  SAmp = 50;
  SOfs = 250;
  SLen = 255;
  VSeg : Word = $B800;
  Txt  : STRING='TuSoft BBS / Phone: ++359 (0)2 27-64-11      '+
                'Working time: 23h-6h GMT +2      '+
                'SysOp: Ivan Vazarov     ';


VAR
  STab : ARRAY[0..255] OF Word;
  Font : Pointer;



  PROCEDURE TuSoft_LOGO;  EXTERNAL; {$L TUS_LOGO.OBJ}
  PROCEDURE TuSoft_MUSIC; EXTERNAL; {$L TUS_MUSC.OBJ}




{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
 PROCEDURE Set80x25; INLINE($B8/$03/$00/$CD/$10);
 PROCEDURE Font8x8;  INLINE($B8/$12/$11/$B3/$00/$CD/$10);
 PROCEDURE Font8x16; INLINE($B8/$14/$11/$B3/$00/$CD/$10);

 PROCEDURE VRetrace; ASSEMBLER;
 ASM
   MOV DX, 03DAh
   @1: IN AL, DX; TEST AL,08h;  JZ @1;
   @2: IN AL, DX; TEST AL,08h; JNZ @2;
 END;

 FUNCTION GetFontAddress:Pointer; ASSEMBLER;
 ASM
  PUSH BP
  MOV AX, $1130
  MOV BH, 3             { Get address of 8x8 font table }
  INT 10H
  MOV DX, ES            { Segment }
  MOV AX, BP            { Offset }
  POP BP
 END;


{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}








{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
TYPE
  TRgb   = RECORD
    Red  : Byte;
    Green: Byte;
    Blue : Byte;
  END;
  TPal   = ARRAY[0..255] OF TRgb;

VAR
  Pal    : TPal;


PROCEDURE GetVGAPal(VAR APal:TPal); ASSEMBLER;
CONST PalRead=$3C7; PalData=$3C9;
ASM
     LES  DI, APal
     MOV  CX, 256 * 3
     MOV  DX, PalRead  {Write}
     MOV  AL, 0
     OUT  DX, AL       {Set first color}
     MOV  DX, PalData  {Data}
  @Get:
     IN   AL, DX
     STOSB
     LOOP @Get
END;

PROCEDURE SetVGAPal(VAR APal:TPal); ASSEMBLER;
CONST CrtcPort=$3DA; PalWrite=$3C8; PalData=$3C9;
ASM
     PUSH DS
     LDS  SI, APal
     MOV  CX, 256 * 3

     MOV  DX, PalWrite {Write}
     MOV  AL, 0
     OUT  DX, AL       {Set first color}
     MOV  DX, PalData  {Data}

  @Get:
     LODSB
     OUT DX, AL
     LOOP @Get

     POP  DS
END;

PROCEDURE SetIntensity(a1,a2,a3:Byte);
VAR I:Byte;
BEGIN
  Port[$3C8] := $00;
  FOR I := 0 TO 255 DO
  BEGIN
    Port[$3C9] := Pal[I].Red   * a1 DIV 63;
    Port[$3C9] := Pal[I].Green * a2 DIV 63;
    Port[$3C9] := Pal[I].Blue  * a3 DIV 63;
  END;
END;

PROCEDURE FadeDownMax;
VAR I:Byte;
BEGIN
  FOR I := 63 DOWNTO 0 DO
  BEGIN
    PollMusic;
    VRetrace;
    SetIntensity(I,I,I);
  END;
END;

PROCEDURE FadeUpMax;
VAR I:Byte;
BEGIN
  FOR I := 0 TO 63 DO
  BEGIN
    PollMusic;
    VRetrace;
    SetIntensity(I,I,I);
  END;
END;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}








{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE ShowLogo(X,Y:Byte); ASSEMBLER;
ASM
    PUSH DS
    MOV AX, CS
    MOV DS, AX
    MOV AX, 0B800h
    MOV ES, AX
    XOR DI, DI
    MOV SI, OFFSET Tusoft_Logo
    MOV CX, 4000 / 2
    REP MOVSW
    POP DS

    MOV AX, 040h
    MOV ES, AX
    MOV AL, x;  MOV ES:[$50], AL  { Cursor X }
    MOV AL, y;  MOV ES:[$51], AL  { Cursor Y }
END;

PROCEDURE SetImage(CharNum:Char; VAR BitMap); ASSEMBLER;
ASM
        {Get font access}
        {---------------}
	CLI
	MOV	DX, $03C4; { Sequenser }
	MOV	AX, $0402;	OUT	DX, AX
	MOV	AX, $0704;	OUT	DX, AX

	MOV	DX, $03CE;
	MOV	AX, $0204;	OUT	DX, AX
	MOV	AX, $0005;	OUT	DX, AX
	MOV	AX, $0006;	OUT	DX, AX
        {Load char      }
        {---------------}
	PUSH	DS
	LDS	SI, BitMap

	MOV	AX, $A000
	MOV	ES, AX
	XOR	DI, DI

	MOV	AL, CharNum
	MOV	CL, 32
	MUL	CL
	ADD	DI, AX

	MOV	CX, 4
	REP	MOVSW
        POP     DS

        {Release font access}
        {-------------------}
	MOV	DX, $03C4; { Sequenser }
	MOV	AX, $0302;	OUT	DX, AX
	MOV	AX, $0304;	OUT	DX, AX

	MOV	DX, $03CE; { Graphic }
	MOV	AX, $0004;	OUT	DX, AX
	MOV	AX, $1005;	OUT	DX, AX
	MOV	AX, $0E06;	OUT	DX, AX
	STI
END;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}











{***************************************************************************}
{******************************* DO SCROLL TEXT ****************************}
{***************************************************************************}
PROCEDURE ScrollText;
VAR PosTab  : ARRAY[0..79,0..7] OF Word;
    BitMap  : ARRAY[0..79,0..7] OF Byte;
    SCtr    : Byte;
    TCtr    : Byte;
    CurChar : Byte;
    L,B,X,Y : Byte;
    FadeNDX : Byte;
    QuitTime: Boolean;
    Fade    : Boolean;

BEGIN
  FillChar(BitMap,Sizeof(BitMap),0);
  FillChar(PosTab,Sizeof(PosTab),0);
  Sctr := 0; TCtr := 1;

  FadeNDX  := 64;
  Fade     := False;
  QuitTime := False;
  REPEAT
    CurChar := Ord(Txt[TCtr]);
    TCtr := 1+TCtr MOD Length(Txt);
    FOR B := 0 TO 7 DO
    BEGIN
      Move( BitMap[1,0], BitMap[0,0], SizeOf(BitMap) );
      FOR L := 0 TO 7 DO
        IF ((Mem[Seg(Font^):Ofs(Font^)+8*Curchar+L] SHL B) AND 128) <> 0
          THEN BitMap[79,L] := 1 ELSE BitMap[X,Y] := 0;

      VRetrace;
      PollMusic;
      IF Fade THEN
      BEGIN
        Dec(FadeNDX);
        SetIntensity(FadeNDX,FadeNDX,FadeNDX);
      END;
      IF FadeNDX = 1 THEN QuitTime := True;

      FOR X:=0 TO 79 DO FOR Y:=0 TO 7 DO Mem[VSeg:PosTab[X,Y]] := 32;
      FOR X:=0 TO 79 DO FOR Y:=0 TO 7 DO
      BEGIN
        PosTab[X,Y]:=(Y+(STab[(SCtr+X) MOD SLen] DIV 8))*160+X+X;
        IF BitMap[X,Y]=1 THEN Mem[VSeg:PosTab[X,Y]]:=128+STab[(SCtr+X) MOD SLen] MOD 8;
      END;
      Sctr := (SCtr+SSpd) MOD Slen;
    END;

    IF Port[$60] = 1 THEN
    BEGIN
      FadeSong;
      Fade := True;
    END;
  UNTIL QuitTime;
END;
{---------------------------------------------------------------------------}






{---------------------------------------------------------------------------}
{-------------------------------- INITIALIZE -------------------------------}
{---------------------------------------------------------------------------}
PROCEDURE Initialize;
VAR I:Byte; CharSet:ARRAY[0..7] OF Byte; TMPPal:TPal;
BEGIN
  FillChar(TMPPal,SizeOf(TMPPal),0);
  GetVGAPal(Pal);
  FadeDownMax;
  VRetrace;
  Set80x25;
  SetVGAPal(TMPPal);
  Font8x8;
  ShowLogo(1,1);

  Font := GetFontAddress;
  FOR I := 0 TO 7 DO
  BEGIN
    FillChar(CharSet, SizeOf(CharSet),0);
    CharSet[I] := 7;
    SetImage( Chr(128+I), CharSet);
  END;
  FOR I := 0 TO 255 DO STab[i] := Round(Sin(4*PI*I/SLen)*SAmp)+SOfs;

  AdvHSC.SetMode(1,1);
  AdvHSC.PlaySongMemory( @Tusoft_Music );
  FadeUpMax;
END;





{---------------------------------------------------------------------------}
{------------------------------- MAIN PROGRAM ------------------------------}
{---------------------------------------------------------------------------}
VAR
  Index:Byte;

BEGIN
  { Decode copyright msg }
  RandSeed := Length(Copyright) + 48;
  FOR Index := 1 TO Length(Copyright) DO
    Copyright[Index] := Chr(Byte(Copyright[Index]) XOR Random(255) XOR $7A);

  Initialize;
  ScrollText;

  Font8x16;
  ShowLogo(25,23);
  { Show copyright msg }
  ASM
   MOV SI, OFFSET Copyright
   XOR CX, CX
   MOV CL, DS:[SI]
   INC SI
 @Loop:
   LODSB
   MOV AH, 2
   MOV DL, AL
   INT 21h
   LOOP @Loop
  END;
  FadeUpMax;
  StopSong;
  INLINE($FA);
  MemW[Seg0040:$1A] := MemW[Seg0040:$1C];
  INLINE($FB);
END.