{$A+} {Word allign}
{$F-} {Use NEAR calls}
{$G-} {8086 instructions}
{$D-} {Strip debug information}
{$B-} {Short boolean evaluation}
{$L-} {Do not generate local symbols information}
{$M, 1024,0,0}

CONST
  Copyright : STRING[27] = 'cTgfwn|0y'#26'\Ǝ';
                          {'Code & Gfx by The GodFather';}

  PROCEDURE TuSoft_LOGO;  EXTERNAL; {$L TUS_LOGO.OBJ}

CONST
  Size = 360; Amp  = 148;
  Step = 15;  Bars = 3;

VAR
  Pal   : ARRAY[0..3*size-1] OF Byte;
  STab  : ARRAY[0..255] OF Word;
  BarTab: ARRAY[0..Bars-1] OF Word;


 PROCEDURE Set80x25;
   INLINE($B8/$03/$00/$CD/$10);

 PROCEDURE VRetrace; ASSEMBLER;
 ASM
   MOV DX, 03DAh
   @1: IN AL, DX; TEST AL,08h;  JZ @1;
   @2: IN AL, DX; TEST AL,08h; JNZ @2;
 END;

 PROCEDURE PosCursor(X,Y:Byte); ASSEMBLER;
 ASM
	MOV	AH, $0F
	INT	10h
	MOV	AH, $02
	MOV	DL, X
	MOV	DH, Y
	INT	10h
 END;

 PROCEDURE ShowLogo; ASSEMBLER;
 ASM
    PUSH DS
    MOV AX, CS
    MOV DS, AX
    MOV AX, 0B800h
    MOV ES, AX
    XOR DI, DI
    MOV SI, OFFSET Tusoft_Logo
    MOV CX, 4000 / 2
    REP MOVSW
    POP DS
 END;






{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
TYPE
  TRgb   = RECORD
    Red  : Byte;
    Green: Byte;
    Blue : Byte;
  END;
  TPal   = ARRAY[0..255] OF TRgb;

VAR
  Pallete: TPal;


PROCEDURE GetVGAPal(VAR APal:TPal); ASSEMBLER;
CONST PalRead=$3C7; PalData=$3C9;
ASM
     LES  DI, APal
     MOV  CX, 256 * 3
     MOV  DX, PalRead  {Write}
     MOV  AL, 0
     OUT  DX, AL       {Set first color}
     MOV  DX, PalData  {Data}
  @Get:
     IN   AL, DX
     STOSB
     LOOP @Get
END;

PROCEDURE SetVGAPal(VAR APal:TPal); ASSEMBLER;
CONST CrtcPort=$3DA; PalWrite=$3C8; PalData=$3C9;
ASM
     PUSH DS
     LDS  SI, APal
     MOV  CX, 256 * 3

     MOV  DX, PalWrite {Write}
     MOV  AL, 0
     OUT  DX, AL       {Set first color}
     MOV  DX, PalData  {Data}

  @Get:
     LODSB
     OUT DX, AL
     LOOP @Get

     POP  DS
END;

PROCEDURE SetIntensity(a1,a2,a3:Byte);
VAR I:Byte;
BEGIN
  VRetrace;
  Port[$3C8] := $00;
  FOR I := 0 TO 255 DO
  BEGIN
    Port[$3C9] := Pallete[I].Red   * a1 DIV 63;
    Port[$3C9] := Pallete[I].Green * a2 DIV 63;
    Port[$3C9] := Pallete[I].Blue  * a3 DIV 63;
  END;
END;

PROCEDURE FadeDownMax;
VAR I:Byte;
BEGIN
  FOR I := 63 DOWNTO 0 DO SetIntensity(I,I,I);
END;

PROCEDURE FadeUpMax;
VAR I:Byte;
BEGIN
  FOR I := 0 TO 63 DO SetIntensity(I,I,I);
END;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}





PROCEDURE MoveBars;
VAR I,N:Word;
BEGIN
  FillChar(Pal,3*Size,0);
  FOR n:=0 to bars-1 do
  BEGIN
    FOR I:=0 TO 31 DO Pal[N MOD 3+3*STab[BarTab[N]]+3*I]:=2*I;
    FOR I:=0 TO 31 DO Pal[N MOD 3+3*STab[BarTab[N]]+3*32+3*I]:=63-2*I;
    BarTab[N] := 1+BarTab[N] MOD 255;
  END;
END;



PROCEDURE CopperBars;
VAR CC,L:Word;
BEGIN
  ASM CLI END;
  VRetrace;
  CC := 0;
  FOR L := 0 TO Size-1 DO
  BEGIN
    Port[$3C8] := 0;
    Port[$3C9] := Pal[CC];
    Port[$3C9] := Pal[CC+1];
    WHILE (Port[$3DA] AND 1) <> 0 DO;
    WHILE (Port[$3DA] AND 1) =  0 DO;
    Port[$3C9] := Pal[CC+2];
    Inc(CC, 3);
  END;
  ASM STI END;
END;



PROCEDURE Initialize;
VAR I:Byte; TMPPal:TPal;
BEGIN
  FillChar(Pal,SizeOf(Pal),0);
  FOR I := 0 TO Bars-1 DO BarTab[I] := Step*I;
  FOR I := 0 TO 255 DO STab[I] := Round(Sin(2*PI*I/255)*Amp)+Amp;
  GetVGAPal(Pallete);
  FillChar(TMPPal,SizeOf(TMPPal),0);
  FadeDownMax;
  Set80x25;
  SetVGAPal(TMPPal);
  ShowLogo;
  PosCursor(25,23);
END;




{------------------------------- MAIN PROGRAM ------------------------------}
VAR
  Index:Byte;

BEGIN
  { Decode copyright msg }
  RandSeed := Length(Copyright) + 48;
  FOR Index := 1 TO Length(Copyright) DO
    Copyright[Index] := Chr(Byte(Copyright[Index]) XOR Random(255) XOR $7A);

  Initialize;
  { Show copyright msg }
  ASM
   MOV SI, OFFSET Copyright
   XOR CX, CX
   MOV CL, DS:[SI]
   INC SI
 @Loop:
   LODSB
   MOV AH, 2
   MOV DL, AL
   INT 21h
   LOOP @Loop
  END;
  PosCursor(0,0);
  FadeUpMax;
  REPEAT
    MoveBars;
    CopperBars;
  UNTIL Port[$60] = 1;
  PosCursor(1,23);
  INLINE($FA);
  MemW[Seg0040:$1A] := MemW[Seg0040:$1C];
  INLINE($FB);
END.
